/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TDmTabledef.TDmTabledefPath;
import de.ship.db.tables.records.TDmTransposeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTranspose extends TableImpl<TDmTransposeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_transpose</code>
     */
    public static final TDmTranspose T_DM_TRANSPOSE = new TDmTranspose();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTransposeRecord> getRecordType() {
        return TDmTransposeRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_transpose.lastchange</code>.
     */
    public final TableField<TDmTransposeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_transpose.pk</code>.
     */
    public final TableField<TDmTransposeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_transpose.fk_tabledef</code>. reference
     * to T_DM_TABLEDEF.pk
     */
    public final TableField<TDmTransposeRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER.nullable(false), this, "reference to T_DM_TABLEDEF.pk");

    private TDmTranspose(Name alias, Table<TDmTransposeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTranspose(Name alias, Table<TDmTransposeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_transpose</code> table reference
     */
    public TDmTranspose(String alias) {
        this(DSL.name(alias), T_DM_TRANSPOSE);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_transpose</code> table reference
     */
    public TDmTranspose(Name alias) {
        this(alias, T_DM_TRANSPOSE);
    }

    /**
     * Create a <code>common_dd.t_dm_transpose</code> table reference
     */
    public TDmTranspose() {
        this(DSL.name("t_dm_transpose"), null);
    }

    public <O extends Record> TDmTranspose(Table<O> path, ForeignKey<O, TDmTransposeRecord> childPath, InverseForeignKey<O, TDmTransposeRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TRANSPOSE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTransposePath extends TDmTranspose implements Path<TDmTransposeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTransposePath(Table<O> path, ForeignKey<O, TDmTransposeRecord> childPath, InverseForeignKey<O, TDmTransposeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTransposePath(Name alias, Table<TDmTransposeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTransposePath as(String alias) {
            return new TDmTransposePath(DSL.name(alias), this);
        }

        @Override
        public TDmTransposePath as(Name alias) {
            return new TDmTransposePath(alias, this);
        }

        @Override
        public TDmTransposePath as(Table<?> alias) {
            return new TDmTransposePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTransposeRecord, Integer> getIdentity() {
        return (Identity<TDmTransposeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTransposeRecord> getPrimaryKey() {
        return Keys.PK_DM_TRANSPOSE;
    }

    @Override
    public List<UniqueKey<TDmTransposeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_TRANSPOSE);
    }

    @Override
    public List<ForeignKey<TDmTransposeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TRANSPOSE__FK_TRANSPOSE_TABLEDEF);
    }

    private transient TDmTabledefPath _tDmTabledef;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_tabledef</code>
     * table.
     */
    public TDmTabledefPath tDmTabledef() {
        if (_tDmTabledef == null)
            _tDmTabledef = new TDmTabledefPath(this, Keys.T_DM_TRANSPOSE__FK_TRANSPOSE_TABLEDEF, null);

        return _tDmTabledef;
    }

    @Override
    public TDmTranspose as(String alias) {
        return new TDmTranspose(DSL.name(alias), this);
    }

    @Override
    public TDmTranspose as(Name alias) {
        return new TDmTranspose(alias, this);
    }

    @Override
    public TDmTranspose as(Table<?> alias) {
        return new TDmTranspose(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTranspose rename(String name) {
        return new TDmTranspose(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTranspose rename(Name name) {
        return new TDmTranspose(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTranspose rename(Table<?> name) {
        return new TDmTranspose(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose where(Condition condition) {
        return new TDmTranspose(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTranspose where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTranspose where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTranspose where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTranspose where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTranspose whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
